// ActionScript Document
#include "NetDebug.as" 
#include "NetServices.as" 
#include "DataGlue.as"

// ------------------------- USER CHANGEABLE AREA ----------------
// change the URL to match YOUR web server - this one matches MINE

ourURL = "http://bear-faced-cow.local:8080/cfusion/flashservices/gateway";

timeSlot_x = 100;
timeSlot_y = 53;

// ------------------------- END USER CHANGEABLE AREA ------------

tomorrowBtn.onRelease = tomorrow;		// set our two date changing buttons to that when they get hit
yesterdayBtn.onRelease = yesterday;		// they will call these functions

bookingButtons = new Array();

for( loop = 0; loop < 10; loop++ )
{
	_root.attachMovie( "Rectangle Button", "booking" + loop, 100 + loop );
	bookingButtons[loop] = new bookingBtn( 9 + loop, _root["booking" + loop] );
	_root["booking" + loop].onRelease = _root["btnPressed" + loop];	// point our handler to our button handling functions
	
	_root["booking" + loop]._x = timeSlot_x;
	_root["booking" + loop]._y = (loop * parseInt(_root["booking" + loop]._height)) + timeSlot_y; // calculate our y within our movie
}

// ------------------------- FUNCTIONS ---------------------------

function tomorrow()
{
	_root.theDate.setTime( _root.theDate.getTime() + (24 * 60 * 60 * 1000) );
	_root.theDate = new Date( _root.theDate.getFullYear(), _root.theDate.getMonth(), _root.theDate.getDate(), 0, 0, 0, 0 ); // and remove the time to set it to 12:00am by default

	setOurDate( _root.theDate );
	
	_root.facilities.getBooking( facilitiesList.getSelectedItem().facility, _root.theDate.getTime() / 1000);	

}

function yesterday()
{
	_root.theDate.setTime( _root.theDate.getTime() - (24 * 60 * 60 * 1000) );
	_root.theDate = new Date( _root.theDate.getFullYear(), _root.theDate.getMonth(), _root.theDate.getDate(), 0, 0, 0, 0 ); // and remove the time to set it to 12:00am by default

	setOurDate( _root.theDate );

	_root.facilities.getBooking( facilitiesList.getSelectedItem().facility, _root.theDate.getTime() / 1000);	
}

function btnPressed0()
{
	_root.bookingButtons[0].btnPressed();
}
function btnPressed1()
{
	_root.bookingButtons[1].btnPressed();
}
function btnPressed2()
{
	_root.bookingButtons[2].btnPressed();
}
function btnPressed3()
{
	_root.bookingButtons[3].btnPressed();
}
function btnPressed4()
{
	_root.bookingButtons[4].btnPressed();
}
function btnPressed5()
{
	_root.bookingButtons[5].btnPressed();
}
function btnPressed6()
{
	_root.bookingButtons[6].btnPressed();
}
function btnPressed7()
{
	_root.bookingButtons[7].btnPressed();
}
function btnPressed8()
{
	_root.bookingButtons[8].btnPressed();
}
function btnPressed9()
{
	_root.bookingButtons[9].btnPressed();
}

function setOurDate( aDate )
{
	var monthArray = new Array( "Jan.", "Feb.", "Mar.", "Apr.", "May", "June", "July", "Aug.", "Sept.", "Oct.", "Nov.", "Dec." );
	
	// put our date in our text box
	_root.dateDisp.text = monthArray[aDate.getMonth()] + " " + aDate.getDate() + ", " + aDate.getFullYear();
}

function getFacility()
{
	var ourSelection = _root.facilitiesList.getSelectedItem()
	// trace( "Facility Chosen: " + ourSelection.facility );
	
	// call our CFMX web service with our data from our comboBox along with a UNIX timeStamp of our date without the milliseconds
	for( loop = 0; loop < 10; loop++ )
	{
		_root.bookingButtons[loop].setBooking( 0 );	// init our state
	}
	
	_root.facilities.getBooking( ourSelection.facility, _root.theDate.getTime() / 1000 );
}

// --------------------- FLASH REMOTING METHODS ----------------------
// these functions are called automagically from our web service call

function listFacilities_Result( result )
{
	_root.facilitiesList.setDataProvider( result );
}

function addBooking_Result( result )
{
	trace( "Create Booking: " + result );
	
	_root.facilities.getBooking( facilitiesList.getSelectedItem().facility, _root.theDate.getTime() / 1000);	
}

function removeBooking_Result( result )
{
	trace( "Remove Booking: " + result );

	_root.facilities.getBooking( facilitiesList.getSelectedItem().facility, _root.theDate.getTime()/ 1000 );	
}

function getBooking_Result( result )
{
	trace( "Received Bookings for " + _root.theDate );

	for( loop = 0; loop < 10; loop++ )
	{		
		var aTimeStamp = ( _root.theDate.getTime() / 1000 ) + ( ( loop + 9 ) *  3600 ) ; // get our timestamp
		_root.bookingButtons[loop].setBooking( 0 );	// init our state
		
		// iterate through our results that were returned from ColdFusion MX
		
		for( resultLoop = 0; resultLoop < result.items.length; resultLoop++ )
		{
			row = result.items[resultLoop];
			
			trace( "Booking ID: " + row.bookingID + " - Start: " + row.startDate + " (" + row.bookingStart + ") - Duration: " + row.duration );
			
			if( aTimeStamp >= row.bookingStart && aTimeStamp <= (row.bookingStart + row.duration) )
			{
				_root.bookingButtons[loop].setBooking( row.bookingID );	// set our button
			}	
		}
	}
}

// --------------------- bookingBtn OBJECT ----------------------------
// by: Jordan L. Chilcott, Interactivity Unlimited

// This will handle the various booking buttons that are displayed
// and handled within the timesheet 

function bookingBtn( timeSlot, btn )
{
	this.hour = timeSlot;
	this.btn = btn;	// used to control our button
	
	this.bookingID = 0;		// initialize our booking ID here	
}

bookingBtn.prototype.createBooking = function ()
{
	aDate = new Date( _root.theDate.getFullYear(), _root.theDate.getMonth(), _root.theDate.getDate(), this.hour, 0, 0, 0 ); // create a date object of the time we want to book
	
	trace( "Sending booking msg: " + _root.facilitiesList.getSelectedItem().facility + "," + aDate + "," + 3599 );
	facilities.addBooking( _root.facilitiesList.getSelectedItem().facility, aDate.getTime() /  1000, 3599 ); // book an hour at the alloted timeslot
}

bookingBtn.prototype.removeBooking = function ()
{
	_root.facilities.removeBooking( this.bookingID );
}

bookingBtn.prototype.setBooking = function ( bookingID )
{
	trace( "Setting booking ID to: " + bookingID );
	
	this.bookingID = bookingID;
	this.btn._alpha = this.bookingID ? 30 : 0;	// if we have a booking, shade the button
}

// this is our public button handler

bookingBtn.prototype.btnPressed = function ()
{
	trace( "Button Pressed!");
	
	if( this.bookingID )
	{
		this.removeBooking();
	}
	
	else
	{
		this.createBooking();
	}
}

// --------------------------------------------------------------------

_root.theDate = new Date(); // start off our date with today
_root.theDate = new Date( _root.theDate.getFullYear(), _root.theDate.getMonth(), _root.theDate.getDate(), 0, 0, 0, 0 ); // and remove the time to set it to 12:00am by default

setOurDate( _root.theDate );

// connect to the Flash Remoting service provider 
if (isGatewayOpen == null) { 
  
  // do this code only once 
  isGatewayOpen = true; 
  // Make the Gateway connection 
  NetServices.setDefaultGatewayUrl(ourURL);
  
  gatewayConnnection = NetServices.createGatewayConnection(); 
  
  // Connect to our web service (aka: facilities.cfc)
  _root.facilities = gatewayConnnection.getService("oakbridges.facilities", this); 

  // Call our Web service: get our list of facilities for our dropdown list
  _root.facilities.listFacilities();  
}


