<cfcomponent>
	<!--- Get a list of all of our facilities --->
	<cffunction name="listFacilities" access="remote" returntype="query">
		<cfquery name="listFacilities" datasource="oakbridge">
			SELECT facility FROM facilities
		</cfquery>
		<cfreturn listFacilities>
	</cffunction>
	
	<!--- Get a list of all of our bookings for a particular facility on a particular date --->
	<cffunction name="getBooking" access="remote" returntype="query">
		<cfargument name="facility" type="string">
		<cfargument name="theDate" type="numeric">
		<cfquery name="getBooking" datasource="oakbridge">
			SELECT *, UNIX_TIMESTAMP( startDate ) as bookingStart FROM booking
			INNER JOIN facilities USING( facilityID )
			WHERE facility='#facility#'
			AND startDate BETWEEN FROM_UNIXTIME( #theDate# ) AND FROM_UNIXTIME( #theDate# ) + INTERVAL 1 DAY
		</cfquery>
		<cfreturn getBooking>
	</cffunction>
	
	<!--- Add a booking --->
	<cffunction name="addBooking" access="remote" returntype="string">
		<cfargument name="facility" type="string">
		<cfargument name="startDate" type="numeric">
		<cfargument name="duration" type="numeric">
		<cfquery name="addBooking" datasource="oakbridge">
			INSERT INTO booking (facilityID, startDate, duration)
			SELECT facilityID, FROM_UNIXTIME( #startDate# ), #duration#
			FROM facilities
			WHERE facility = '#facility#'
		</cfquery>
		<cfreturn "SUCCESS">
	</cffunction>
	
	<!--- Remove Booking --->
	<cffunction name="removeBooking" access="remote" returntype="string">
		<cfargument name="bookingID" type="numeric">
		<cfquery name="removeBooking" datasource="oakbridge">
			DELETE FROM booking
			WHERE bookingID=#bookingID#
		</cfquery>
		<cfreturn "SUCCESS">
	</cffunction>
</cfcomponent>